signature BRAMInitiator where {
import BRAMInitiatorWires;
			 
import Environment;
		     
import FIFOF_;
		
import FIFOF;
	       
import FIFO;
	      
import BRAM;
	   
interface (BRAMInitiator.BRAMInitiator :: * -> *) idx_type = {
    BRAMInitiator.bram :: BRAM.BRAM idx_type (Prelude.Bit 32);
    BRAMInitiator.bramInitiatorWires :: BRAMInitiatorWires.BRAMInitiatorWires idx_type
};
 
interface (BRAMInitiator.BRAMInitiatorFlat :: * -> *) idx_type = {
    BRAMInitiator.read_resp :: Prelude.ActionValue
			       (Prelude.Bit 32) {-# arg_names = [] #-};
    BRAMInitiator.read_req :: idx_type -> Prelude.Action {-# arg_names = [idx] #-};
    BRAMInitiator.write :: idx_type ->
			   Prelude.Bit 32 -> Prelude.Action {-# arg_names = [idx, value] #-};
    BRAMInitiator.bramCLK :: Prelude.Bit 1 {-# arg_names = [] #-};
    BRAMInitiator.bramRST :: Prelude.Bit 1 {-# arg_names = [] #-};
    BRAMInitiator.bramAddr :: idx_type {-# arg_names = [] #-};
    BRAMInitiator.bramDout :: Prelude.Bit 32 {-# arg_names = [] #-};
    BRAMInitiator.bramDin :: Prelude.Bit 32 -> Prelude.Action {-# arg_names = [value] #-};
    BRAMInitiator.bramWEN :: Prelude.Bit 4 {-# arg_names = [] #-};
    BRAMInitiator.bramEN :: Prelude.Bit 1 {-# arg_names = [] #-}
};
 
BRAMInitiator.mkBRAMInitiator :: (Prelude.IsModule _m__ _c__,
				  Prelude.Bits idx_type idx,
				  Prelude.Literal idx_type) =>
				 _m__ (BRAMInitiator.BRAMInitiator idx_type);
									    
BRAMInitiator.mkBRAMInitiatorFlat :: (Prelude.Literal idx_type,
				      Prelude.Bits idx_type _sn0,
				      Prelude.IsModule _m__ _c__) =>
				     _m__ (BRAMInitiator.BRAMInitiatorFlat idx_type);
										    
interface (BRAMInitiator._BRAMInitiator.BRAMInitiatorFlat49 :: # -> # -> # -> *) _n0 _n1 _n2 = {
    BRAMInitiator.read_resp :: Prelude.ActionValue_ _n2 {-# prefixs = "read_resp",
								  result = "read_resp",
								  ready = "RDY_read_resp",
								  enable = "EN_read_resp" #-};
    BRAMInitiator.RDY_read_resp :: Prelude.Bit 1;
    BRAMInitiator.read_req :: Prelude.Bit _n0 ->
			      Prelude.ActionValue_ _n1 {-# prefixs = "read_req",
								 result = "read_req",
								 ready = "RDY_read_req",
								 enable = "EN_read_req" #-};
    BRAMInitiator.RDY_read_req :: Prelude.Bit 1;
    BRAMInitiator.write :: Prelude.Bit _n0 ->
			   Prelude.Bit 32 -> Prelude.ActionValue_ _n1 {-# prefixs = "write",
										      result = "write",
										      ready = "RDY_write",
										      enable = "EN_write" #-};
    BRAMInitiator.bramCLK :: Prelude.Bit 1 {-# prefixs = "bramCLK",
						     result = "bramCLK",
						     ready = "RDY_bramCLK",
						     enable = "EN_bramCLK" #-};
    BRAMInitiator.bramRST :: Prelude.Bit 1 {-# prefixs = "bramRST",
						     result = "bramRST",
						     ready = "RDY_bramRST",
						     enable = "EN_bramRST" #-};
    BRAMInitiator.bramAddr :: Prelude.Bit _n0 {-# prefixs = "bramAddr",
							result = "bramAddr",
							ready = "RDY_bramAddr",
							enable = "EN_bramAddr" #-};
    BRAMInitiator.bramDout :: Prelude.Bit 32 {-# prefixs = "bramDout",
						       result = "bramDout",
						       ready = "RDY_bramDout",
						       enable = "EN_bramDout" #-};
    BRAMInitiator.bramDin :: Prelude.Bit 32 ->
			     Prelude.ActionValue_ _n1 {-# prefixs = "bramDin",
								result = "bramDin",
								ready = "RDY_bramDin",
								enable = "EN_bramDin" #-};
    BRAMInitiator.bramWEN :: Prelude.Bit 4 {-# prefixs = "bramWEN",
						     result = "bramWEN",
						     ready = "RDY_bramWEN",
						     enable = "EN_bramWEN" #-};
    BRAMInitiator.bramEN :: Prelude.Bit 1 {-# prefixs = "bramEN",
						    result = "bramEN",
						    ready = "RDY_bramEN",
						    enable = "EN_bramEN" #-}
};
 
type (BRAM.BRAM :: * -> * -> *) _v100 _v101;
					   
type (BRAMInitiatorWires.BRAMInitiatorWires :: * -> *) _v100
}
