// Global Includes 
import GetPut::*;


// Local Includes
`include "Common.bsv"
import BRAMTargetWires::*;
import BRAMInitiatorWires::*;

interface PPCInterface#(numeric type log_functional_units,
                numeric type log_page_size);

  interface BRAMTargetWires                    bramTargetWires;
  interface BRAMInitiatorWires                 bramInitiatorWires;
  interface Get#(Instruction#(log_functional_units,
                              log_page_size))   instructionOutput;
 
endinterface
