#ifndef _MATRIX_POINTERS_
#define _MATRIX_POINTERS_

// Contains the base pointers to the matrix memories
// used in the simulator

#include "instructions.h"

UInt64 aMatrix = (UInt64)0x0000000000000000;
UInt64 bMatrix = (UInt64)0x0000000000400000;
UInt64 cMatrix = (UInt64)0x0000000000800000;
UInt64 scratch = (UInt64)0x0000000000c00000;
UInt64 maxAdd  = (UInt64)0x0000000000ffffff;

#endif //_MATRIX_POINTERS_
